#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_EffectCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_EffectCFG> Fish_EffectCFG::msSingleton(nullptr);

int Fish_EffectCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_EffectCFGData* Fish_EffectCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_EffectCFGData>& Fish_EffectCFG::GetMapData()
{
	return mMapData;
}

void Fish_EffectCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_EffectCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_EffectCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mEffectType = element->IntAttribute("EffectType");
		{
			const char* ResParams = element->Attribute("ResParams");
			std::vector<std::string> vecResParams;
			boost::split(vecResParams, ResParams, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecResParams.size(); i++)
			{
				data.mResParams.push_back(vecResParams[i]);
			}
		}
		data.mDuration = element->FloatAttribute("Duration");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_EffectCFG::Load()
{
	Load("../Config/Fish_EffectCFG.xml");
}

Fish_EffectCFG* Fish_EffectCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_EffectCFG());
	}
	return msSingleton.get();
}
